<?PHP
// IT DISPLAYS THE NUMBER OF STUDENTS AND ACADEMIC STAFF (EDITING TEACHERS) FOR A SELECTED MAIN CATEGORY.
//EVEN IF STUDENTS ARE ENROLLED IN MORE THAN 1 COURSE, THEY ARE ONLY COUNTED ONCE. THE SAME FOR EDITING TEACHERS
// IT ALSO DISPLAYS THE TOTAL NUMBER OF STUDENTS ENROLLED IN EACH ONE OF THE COURSES THAT BELONG TO THAT MAIN CATEGORY

require_once("../../config.php");
require_login();

################################
# url
################################
# Coloco esto así, pero después habría que 
# tomarlo directo del config.php pero no se como hacerlo hoy
$sitio=$CFG->wwwroot;
$urlcat=$sitio."/course/category.php?id=";
$urlcurso=$sitio."/course/view.php?id=";
$urlestcat=$sitio."/estadisticas/content/result_categories.php?catid=";
$urlestcurso=$sitio."/estadisticas/content/result_courses.php?courseid=";

################################
# Archivo
################################
# Archivo: Seteos grales
$csv_end = "  
";  
$csv_sep = ";";
$csv_file = "nada";  
$csv="";
# Creo los encabezados
$csv.='Curso'.$csv_sep.'Categoría "padre"'.$csv_sep.'Recursos'.$csv_sep.'Estud'
.$csv_sep.'Tareas'.$csv_sep.'Chats'.$csv_sep.'Consultas'.$csv_sep.'Foros'
.$csv_sep.'Glosarios'.$csv_sep.'HotPots'.$csv_sep.'Cuestionarios'.$csv_sep.'Wikis'.$csv_end;
###############################

global $USER;
$adminContext = get_context_instance(CONTEXT_SYSTEM, SITEID);
if(!user_has_role_assignment($USER->id,1,$adminContext->id)){
	redirect("block.php");
	exit();
}

#CHECK URL ID
$iCourseID = optional_param('courseid',0,PARAM_INT);
$iCatID = optional_param('catid',-1,PARAM_INT);

if($iCourseID<1 && $iCatID<1){
	redirect("../index.php");
	exit();
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//ES" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Estadísticas Moodle</title>
<body>

<link rel="stylesheet" type="text/css" href="../styles/default.css" media="screen" />
<link rel="stylesheet" type="text/css" href="../styles/print.css" media="print" />
</head>

<body>
<p> <div style="text-align: center;"><img src="../images/moodle.png" alt="logo" /></div> </p>
<div id="search">
</p><span class="title">Estadísticas Moodle - categoría</span></p>
</div>
<br />
<?php
///Despliega los totales

if($iCatID>0){
	$categories = get_categories('','name ASC');
	foreach($categories as $c){
		if($c->id==$iCatID){
			echo '<p><img src="../images/news.gif" alt="icon" />&nbsp;Información sobre: '.$c->name.'</p>';
		}
	}

//Construyo el nombre de archivo
$csv_file = "categoria.csv";
# esto no lo hago así porque cada vez me genera un archivo nuevo y no se cómo manejarlo
#$csv_file = '/tmp/'.date("Ymd").'_'.$c->name.'.csv';

echo '<p>Generado:&nbsp;'.date("d F Y - G:i").'</p>';
?>

<?php
//FUNCTIONS/////////////////////////////////////////////////////////////
function lastAccess($timestamp)
{
	if(date("d F Y - G:i",$timestamp)>date("d F Y - G:i",0)){
		$diff = time()-$timestamp;
		$days = $diff/(60 * 60 * 24);
		if($days>1){
			$days = ceil($days);
		}else{
			$days = 0;
		}
	}else{
		$days = -1;
	}

	return $days;
}

//INITIALIZE COUNTERS

$num_courses[$iCatID]=0 ;
$num_students[$iCatID]=0 ;
$num_teachers[$iCatID]=0;


	$sSQL = 'SELECT id, visible FROM mdl_course WHERE category = '.$iCatID;
	$query_students='SELECT DISTINCT u.id
FROM mdl_user u, mdl_role_Assignments a, mdl_role r, mdl_context c, mdl_course co, mdl_course_categories ca
WHERE (a.roleid =5 AND r.name = "Student" AND a.userid=u.id)AND (a.contextid = c.id AND c.instanceid = co.id)
AND (co.category = ca.id AND co.visible =1)AND (ca.id ='.$iCatID;

$query_teachers='SELECT DISTINCT  u.id
FROM mdl_user u, mdl_role_Assignments a, mdl_role r, mdl_context c, mdl_course co, mdl_course_categories ca
WHERE (a.roleid =3 AND r.name = "Teacher" AND a.userid=u.id)AND (a.contextid = c.id AND c.instanceid = co.id)
AND (co.category = ca.id AND co.visible =1)AND (ca.id ='.$iCatID;


//GET ALL THE SUBNESTED SUBCATEGORIES FOR THE CHOSEN MAIN CATEGORY WE HAVE PASSED AS A PARAMETER

	$aCategories = get_all_subcategories($iCatID);
	if(count($aCategories)>0){
		foreach($aCategories as $cat){
			$sSQL .= ' OR category = '.$cat;
			$query_students .= ' OR ca.id = '.$cat;
			$query_teachers .= ' OR ca.id = '.$cat;
		}
  	}

	$query_students .= ' )';
	$query_teachers .= ' )';

	$courses = get_records_sql($sSQL);
	$students= get_records_sql($query_students);
	$teachers= get_records_sql($query_teachers);

$num_students[$iCatID]=count($students);
$num_teachers[$iCatID]=count($teachers);


#por lupa probando creac tabla
echo '<table>';
echo '<tr><td width="20%" class="dark">Curso</td><td class="dark">Categor&iacute;a "padre"</td><td class="dark">Recursos</td><td class="dark">Estud</td><td class="dark">Tarea</td><td class="dark">Chat</td><td class="dark">Consulta</td><td class="dark">foros</td><td class="dark">Glosarios</td><td class="dark">HotPot</td><td class="dark">Cuestionario</td><td class="dark">Wiki</td></tr>';

foreach($courses as $c){

	$iCourseID = $c->id;

	#MAIN QUERIES
	$context = get_context_instance(CONTEXT_COURSE, $iCourseID);
	$oCourseResult = get_record_select('course','id='.$iCourseID,'fullname,timecreated,timemodified,category');
	$aoStudentDetailsResult = get_role_users(5, $context);

	//ACTIVITY QUERIES
	$iAssignmentCount = count_records_select('assignment','course='.$iCourseID);
	$iChatCount = count_records_select('chat','course='.$iCourseID);
	$iChoiceCount = count_records_select('choice','course='.$iCourseID);
	$iForumCount = count_records_select('forum','course='.$iCourseID);
	$iGlossaryCount = count_records_select('glossary','course='.$iCourseID);
	$iHotPotCount = count_records_select('hotpot','course='.$iCourseID);
	#$iQuestionCount = count_records_select('questionnaire','course='.$iCourseID);
	$iQuizCount = count_records_select('quiz','course='.$iCourseID);
	$iWikiCount = count_records_select('wiki','course='.$iCourseID);

	//Consulto por los recursos
	$iResourceCount = count_records_select('resource','course='.$iCourseID);

	//LAST ACCESS FUNCTIONALITY
	$rsLastAccessDetailsResult = get_records_sql("SELECT mdl_user.id,mdl_user_lastaccess.timeaccess FROM mdl_user LEFT JOIN mdl_user_lastaccess ON mdl_user.id=mdl_user_lastaccess.userid WHERE mdl_user_lastaccess.courseid = ".$iCourseID.";");
	$aLastAccess = array();

	foreach($rsLastAccessDetailsResult as $record){
		$aLastAccess[$record->id]=$record->timeaccess;
	}

	$iStudentNever = 0;
	$sStudentOutputString = '';
	$sStudentOutputString .='<p>';
	$sStudentOutputString .= '<span class="title">Detalles de estudiante: </span><br />';
	if(empty($aoStudentDetailsResult)){
		$sStudentOutputString .= "Ninguno matriculado";
	}
	else{
		$sStudentOutputString .= '<table>';
		$sStudentOutputString .= '<tr><th scope="col">Nombre completo:</th><th scope="col">Usuario:</th><th scope="col">Último acceso:</th></tr>';
		$iLoop = 0;
		foreach($aoStudentDetailsResult as $record){
			if($iLoop%2<1){
				$sHighlight = "odd";
			}else{
			$sHighlight = "even";
			}
		$sStudentOutputString .= '<tr><td class="'.$sHighlight.'">'.$record->lastname.', '.$record->firstname.'</td><td class="'.$sHighlight.'">'.$record->username.'</td><td class="'.$sHighlight.'">';
		if(empty($aLastAccess[$record->id])){
			$sStudentOutputString .= 'Nunca';
			$iStudentNever++;
		}else{
			if(lastAccess($aLastAccess[$record->id])>0){
				$sStudentOutputString .=  lastAccess($aLastAccess[$record->id]).' Día(s) atrás';
				if(lastAccess($aLastAccess[$record->id])<11){
	
				}
			}else{
				$sStudentOutputString .=  'Hoy';

			}	
		}
		$sStudentOutputString .= '</td></tr>';
		$iLoop++;
		}
		$sStudentOutputString .= '</table>';
	}
	$sStudentOutputString .= '</p>';

	//IT ONLY DISPLAYS VISIBLE COURSES AND WITH STUDENTS ENROLLED
	if(!empty($aoStudentDetailsResult) && $c->visible==1 ){
		$num_courses[$iCatID]+=1 ;
		//Obtengo el nombre de la categiría padre
		$oCatResult = get_record_select('course_categories','id='.$oCourseResult->category,'name');
		echo '<tr>';
		//imprimo nombre de curso con enlaces a más estadísticas y a EVA
		echo '<td class="dark" width="20%><span class="bold"><a href="'.$urlestcurso.$iCourseID.'">'.$oCourseResult->fullname.'</a> - 
			<a href="'.$urlcurso.$iCourseID.'" target="_blank">[en EVA]</a></span></td>';
		//imprimo nombre de categoría padre con enlaces a más estadísticas y a EVA
		echo '<td class="even">&nbsp;<a href="'.$urlestcat.$oCourseResult->category.'">'.$oCatResult->name.'</a> - 
			<a href="'.$urlcat.$oCourseResult->category.'" target="_blank">[en EVA]</a></td>';
		// Oculto la fecha de creación por comodidad
		// echo '<td  class="even">'.date("d F Y - G:i",$oCourseResult->timecreated).'</td>';
		// Agrego recursos
		echo '<td  class="even">&nbsp;'.$iResourceCount.'&nbsp;</td>';
		echo '<td  class="odd">&nbsp;'.count($aoStudentDetailsResult).'&nbsp;</td>';
		echo '<td  class="even">&nbsp;'.$iAssignmentCount.'&nbsp;</td>';
		echo '<td  class="odd">&nbsp;'.$iChatCount.'&nbsp;</td>';
		echo '<td  class="even">&nbsp;'.$iChoiceCount.'&nbsp;</td>';
		echo '<td  class="odd">&nbsp;'.$iForumCount.'&nbsp;</td>';
		echo '<td  class="even">&nbsp;'.$iGlossaryCount.'&nbsp;</td>';
		echo '<td  class="odd">&nbsp;'.$iHotPotCount.'&nbsp;</td>';
		echo '<td  class="even">&nbsp;'.$iQuizCount.'&nbsp;</td>';
		echo '<td  class="odd">&nbsp;'.$iWikiCount.'&nbsp;</td>';
		echo '</tr>';
	
		//Archivo: construyo
		$csv.=$oCourseResult->fullname.$csv_sep.$oCatResult->name.$csv_sep.$iResourceCount
			.$csv_sep.count($aoStudentDetailsResult).$csv_sep.$iAssignmentCount
			.$csv_sep.$iChatCount.$csv_sep.$iChoiceCount.$csv_sep.$iForumCount
			.$csv_sep.$iGlossaryCount.$csv_sep.$iHotPotCount.$csv_sep.$iQuizCount
			.$csv_sep.$iWikiCount.$csv_end;
	}


} # parece ser el fin del for ppal

//Generamos el csv de todos los datos
// Recodifico para que lo arme correctamente
$csv=utf8_encode($csv); 
if (!$handle = fopen($csv_file, "w")) {
	echo "Cannot open file";
	exit;
}
if (fwrite($handle, utf8_decode($csv)) === FALSE) {  
    echo "Cannot write to file";  
    exit;  
}  
# Cerramos archivo
fclose($handle);  

//Por lupa Cierro la tabla
echo '</table>';

#echo '<tr><td><img src="../images/users.gif" alt="icon" /></td><span class="title">Total number of students enrolled: </td><span class="title">&nbsp;'.$num_students[$iCatID].'&nbsp;</span></tr><br>';
#echo '<tr><td><img src="../images/users.gif" alt="icon" /></td><span class="title">Total number of teachers enrolled: </td><span class="title">&nbsp;'.$num_teachers[$iCatID].'&nbsp;</span></tr><br>';
}

echo '<table><tr><td>
		<img src="../images/assignment.gif" alt="icon" />
	</td>
	<td>&nbsp;Número de cursos:</td>
	<td>'.$num_courses[$iCatID].'</td>
	</tr>
	</table>';

echo '<div style="width:100%;border:1px solid #000000;background-color:#cccccc;text-align:center;">-o0o-</div>';

echo '<hr />
	Descargar: <a href="./'.$csv_file.'">'.$csv_file.'</a>&nbsp;&nbsp;|&nbsp;&nbsp; 
	<a href="javascript:print();">Imprimir</a>&nbsp;&nbsp;|&nbsp;&nbsp;
	Volver al: <a href="../index.php">inicio</a>'

?>
</body>
</html>
